\ProvidesPackage{mathsymbols}

%definition symbol
\usepackage{mathtools}
\newcommand{\defined}{\coloneqq}



\newcommand{\pphi}{\varphi}

\DeclareMathOperator{\proj}{Proj}

\DeclareMathOperator{\rank}{rank}
  %for the field
  \newcommand{\kk}{\mathrm{k}}
  \newcommand{\kkcat}{\mathbf{\mathrm{k}}}
  \renewcommand{\varrho}{\nu}
%set stuff
\newcommand{\ssp}{\;\middle|\;}
\newcommand{\lset}{\left\lbrace}
\newcommand{\rset}{\right\rbrace}
\newcommand{\sse}{\subseteq}
\newcommand{\spse}{\supseteq}
\usepackage{amssymb}
\newcommand{\ssne}{\subsetneq}
\newcommand{\inv}{^{-1}}

%for general maps
\DeclareMathOperator{\id}{id}
\newcommand{\homr}{\hom^{\mathrm{R}}}
\newcommand{\homrr}{\hom_{R'}}
\DeclareMathOperator{\End}{End}
\DeclareMathOperator{\coker}{coker}

%for maps from
\usepackage{stmaryrd}
\newcommand{\inarr}{\xhookrightarrow{}}
\newcommand{\surarr}{\twoheadrightarrow}






%equivalence relation stuff
\newcommand{\erel}{\sim}
\DeclarePairedDelimiter\eclas{[}{]}
%elements in quotient
\newcommand{\qclass}[1]{\overline{#1}}

%restrictions
\usepackage{xparse}
\NewDocumentCommand{\restrict}{smmO{}}{
  \IfBooleanTF{#1}
    {\left. {#2} \middle|_{#3}^{#4} \right.}
    {{#2} |_{#3}^{#4}}
}
%map stuff
\DeclareMathOperator{\im}{im}
%from ferdinand, for isomorphisms in align
\newcommand{\isomorphism}[1][]{
	\mathrel{\tikz[baseline=(a.base)] \node (a) at (0,0) {$\!\!\longrightarrow\!\!$} node[above=-0.25ex] {\smash{\tiny $\sim$}} node[below=-0.25ex] {$\scriptstyle #1$};}}


%ring stuff
\newcommand{\ida}{\mathfrak{a}}
\newcommand{\idb}{\mathfrak{b}}
\newcommand{\idc}{\mathfrak{c}}
\newcommand{\idp}{\mathfrak{p}}
\newcommand{\idq}{\mathfrak{q}}
\newcommand{\idm}{\mathfrak{m}}
\newcommand{\idn}{\mathfrak{n}}
\newcommand{\unts}{^{\times}}
\DeclarePairedDelimiter\genby{\langle}{\rangle}
\DeclareMathOperator{\nilr}{Nil}
\DeclareMathOperator{\jacr}{Jac}
\DeclareMathOperator{\redr}{red}
\DeclareMathOperator{\quot}{Quot}
\DeclareMathOperator{\rht}{ht}
\newcommand{\symp}[1]{^{(#1)}}
\DeclareMathOperator{\ass}{Ass}
\newcommand{\okk}{\mathcal{O}_K}
\newcommand{\divk}{:_{K}}

%zariski-stuff
\DeclareMathOperator{\spec}{Spec}
\DeclareMathOperator{\maxspec}{MaxSpec}
\DeclareMathOperator{\minspec}{MinSpec}
\newcommand{\smap}{^{\#}}
\DeclareMathOperator{\supp}{Supp}
%divide stuff
\newcommand{\divd}{\mid}

%polynomial rings
\DeclareMathOperator{\eval}{ev}
\DeclarePairedDelimiter{\powerbracket}{[[}{]]}
\newcommand{\polvariable}{t}
\newcommand{\powerseries}{\powerbracket{\polvariable}}
\newcommand{\iinf}{_{i=0}^{\infty}}
\newcommand{\nmind}{_{n-1}}
\newcommand{\ktn}{k[\polvariable_1,\hdots,\polvariable_n]}
%localization
\newcommand{\sloc}{S^{-1}}
\newcommand{\ploc}{_{\idp}}
\newcommand{\qloc}{_{\idq}}
\newcommand{\locmap}{\eta}
\newcommand{\mloc}{_{\idm}}
\DeclareMathOperator{\qfield}{Quot}
\newcommand{\ffield}[1]{\kappa\left(#1\right)}
%numbers
\newcommand{\rationals}{\mathbf{Q}}
\newcommand{\zz}{\mathbf{Z}}
\newcommand{\rr}{\mathbf{R}}
\newcommand{\nn}{\mathbf{N}}
\newcommand{\cc}{\mathbf{C}}
\newcommand{\fp}{\mathbf{F}_p}
\newcommand{\pp}{\mathbf{P}}
\newcommand{\af}{\mathbf{A}}

%varieties
\newcommand{\aspace}{\mathbb{A}}
\DeclareMathOperator{\iop}{I}
\newcommand{\co}{\mathcal{O}}
\DeclareMathOperator{\hhom}{Hom}
\DeclareMathOperator{\ext}{Ext}
%module stuff
\DeclareMathOperator{\lin}{Lin}
\DeclareMathOperator{\mat}{Mat}
\DeclareMathOperator{\sgn}{sgn}
\DeclareMathOperator{\adju}{adju}
\DeclareMathOperator{\tensor}{\otimes}
\DeclareMathOperator{\ann}{Ann}
\DeclareMathOperator{\rng}{rg}
\newcommand{\dmod}{^{\vee}}
\DeclareMathOperator{\pic}{Pic}
%category stuff
\newcommand{\op}[1]{#1^{\mathrm{op}}}
  %font choices
  \usepackage[mathcal]{euscript}
  \newcommand{\catname}[1]{\mathbf{#1}}
  \newcommand{\gencatname}[1]{\mathcal{#1}}

  %opposite:
  \DeclareMathOperator{\opcat}{op}
  \newcommand{\opc}{^{\opcat}}


  %fixed categories
  \newcommand{\cring}{\catname{CRing}}
  \newcommand{\kalgft}{k\text{-}\catname{Alg}^{\text{f.t.}}}
  \newcommand{\topspace}{\catname{Top}}
  \newcommand{\modc}{\catname{Mod}}
  \newcommand{\grmodc}{\text{-}\catname{grMod}}
  \newcommand{\amod}{A\mathrm{-}\modc}
  \newcommand{\setc}{\catname{Set}}
  \newcommand{\abc}{\catname{Ab}}
  \newcommand{\affsch}{\catname{AffSch}}
  \newcommand{\rmod}{R\text{-}\modc}
  \newcommand{\rrmod}{R'\text{-}\modc}
  \newcommand{\slmod}{\sloc R\text{-}\modc}
  \newcommand{\func}{\catname{Fun}}
  \newcommand{\liek}{\catname{Lie}}
  \newcommand{\catcat}{\catname{C}\mathrm{at}}


  %general categories
  \newcommand{\obj}{\mathrm{Ob}}
  \newcommand{\ccat}{\gencatname{C}}
  \newcommand{\acat}{\gencatname{A}}
  \newcommand{\bcat}{\gencatname{B}}
  \newcommand{\scat}{\gencatname{S}}
  \newcommand{\dcat}{\gencatname{D}}
  \newcommand{\kcat}{\gencatname{K}}
  \newcommand{\icat}{\gencatname{I}}

\newcommand{\hh}{\mathrm{H}}
\newcommand{\chh}{\check{\mathrm{H}}}
\newcommand{\rh}{\mathrm{R}}
\newcommand{\ch}{\mathrm{C}}


  %dgcat-stuff
  \newcommand{\digcat}{\mathrm{dgCat}}
  \newcommand{\chainc}{\mathrm{Ch}}
  \newcommand{\dchainc}{\mathrm{Ch}}
  \newcommand{\extrachaink}{\mathrm{CCh(k)}}
  \newcommand{\chainck}{\chainc(\kk)}
  \newcommand{\dchainck}{\dchainc(\kk)}
  \newcommand{\dchaincdg}{\dchainck_{\mathrm{dg}}}
  \newcommand{\chaincdg}{\chainck_{\mathrm{dg}}}
  \newcommand{\chain}[1]{#1}
  \newcommand{\dchain}[1]{#1}
  \newcommand{\zker}{\mathrm{Z}}
  \newcommand{\zn}{\zker^0}
  \newcommand{\shhtyp}{\mathrm{h}}
  \newcommand{\dgg}{\mathrm{dg}}
  \newcommand{\cone}{\mathrm{cone}}
  \newcommand{\homc}{\mathsf{hom}}
  \newcommand{\ndg}{\mathrm{N_{dg}}}
  \newcommand{\dgcat}{\ccat_{\mathrm{dg}}}
  \newcommand{\dgkcat}{\dgcat(\kk)}
  \newcommand{\dghom}[1]{\hom_{\dgcat}\left(#1\right)}
  \newcommand{\amcat}{\ccat\left(\acat\right)}
  \newcommand{\dgacat}{\ccat_{\mathrm{dg}}\left(\acat\right)}
  \newcommand{\dgbcat}{\ccat_{\mathrm{dg}}\left(\bcat\right)}
  \newcommand{\chom}{\mathcal{H}\mathrm{om}}
  \newcommand{\cext}{\mathcal{E}\mathrm{xt}}

  %enriched categories
  \newcommand{\smset}{\mathrm{Set}_{\Delta}}

%misc-stuff
\DeclarePairedDelimiter\abs{\lvert}{\rvert}
\newcommand{\mc}{\colon}
\newcommand{\comp}{\mathrm{comp}}


\newcommand*\mcc{%
        \nobreak
        \mskip6mu plus1mu
        \mathpunct{}%
        \nonscript
        \mkern-\thinmuskip
        {:}%
        \mskip2mu
        \relax
}

%simplicial sets
\newcommand{\qcat}{$\infty$-category}
\newcommand{\sset}[1]{#1_{\bullet}}
\newcommand{\bdelt}{\mathbf{\Delta}}
\newcommand{\nda}{\ndg(\acat)}
\newcommand{\setcat}{\mathrm{Set}}
\newcommand{\ssetcat}{\setcat_{\bdelt}}
\newcommand{\gennerve}[1]{\mathrm{N}_{#1}}
\newcommand{\equalizer}{\mathrm{eq}}
\newcommand{\ordi}[1]{\left[#1\right]}
\newcommand{\nord}{\ordi{n}}
\newcommand{\kmod}{\kk\text{-Mod}}

\DeclareMathOperator{\colim}{colim}
\DeclareMathOperator{\nattraf}{NatTraf}
\DeclareMathOperator{\msurj}{Surj}

\DeclareMathOperator{\dk}{DK}
\DeclareMathOperator{\ndk}{N_{\dk}}

\newcommand{\sbop}{\mathop{\textstyle\bigoplus}\limits}



\newcommand{\lig}{\mathfrak{g}}
\newcommand{\lih}{\mathfrak{h}}
\DeclarePairedDelimiter{\lb}{[}{]}
\newcommand{\gl}{\mathfrak{gl}}
\DeclareMathOperator{\der}{Der}
\DeclareMathOperator{\ad}{ad}
\newcommand{\lid}{\trianglelefteq}
\newcommand{\lio}{\mathcal{o}}


%sheaf symbols
\newcommand{\shf}{\mathcal{F}}
\newcommand{\shg}{\mathcal{G}}
\newcommand{\shh}{\mathcal{H}}
\newcommand{\shr}{\mathcal{R}}
\newcommand{\ouv}{\mathcal{O}\mathrm{uv}}
\newcommand{\shc}{\mathcal{C}}
\newcommand{\shi}{\mathcal{I}}
\newcommand{\shl}{\mathcal{L}}

\newcommand{\ide}[1]{\mathfrak{#1}}
\newcommand{\aid}{\ide{a}}
\newcommand{\pid}{\ide{p}}
\newcommand{\qid}{\ide{q}}
\newcommand{\ox}{\mathcal{O}_X}
\newcommand{\oy}{\mathcal{O}_Y}
\newcommand{\oxx}{\mathcal{O}_{X,x}}
\newcommand{\oo}{\mathcal{O}}


\DeclareMathOperator{\kf}{k}

\newcommand{\psc}[1]{\mathcal{P}\mathrm{re}{\text{-}}\mathcal{S}\mathrm{h}_{\mathcal{#1}}}
\newcommand{\apsc}{\mathcal{P}\mathrm{re}{\text{-}}\mathcal{S}\mathrm{h}}
\newcommand{\sheaf}[1]{\mathcal{S}\mathrm{h}_{\mathcal{#1}}}
\newcommand{\asheaf}{\mathcal{S}\mathrm{h}}
\newcommand{\pre}{\mathrm{pre}}


\DeclareMathOperator{\mor}{Mor}


%cohomology stuff


\newcommand{\sescd}{[column sep = small]}

\newcommand{\fip}[1]{\times_{#1}}

\newcommand{\modx}{\modc(X,\ox)}
\DeclareMathOperator{\coh}{Coh}
\DeclareMathOperator{\qcoh}{QCoh}

\newcommand{\dual}{^{\vee}}

\DeclareMathOperator{\codim}{codim}
\DeclareMathOperator{\wdiv}{Div}

\newcommand{\units}{^{\times}}

\DeclareMathOperator{\cl}{Cl}
\DeclareMathOperator{\cacl}{CaCl}

\DeclareMathOperator{\pgln}{PGL}
\DeclareMathOperator{\gln}{GL}
\DeclareMathOperator{\aut}{Aut}

\newcommand{\wtilde}[1]{\widetilde{#1}}

\newcommand{\ds}{\oplus}
\newcommand{\red}{_{\mathrm{red}}}
\newcommand{\nrad}{\mathfrak{N}}

\newcommand{\shm}{\mathcal{M}}
\newcommand{\shn}{\mathcal{N}}

\newcommand{\bt}{\boxtimes}

\DeclareMathOperator{\bs}{Bs}
\DeclareMathOperator{\bl}{Bl}

\newcommand{\she}{\mathcal{E}}
\newcommand{\shs}{\mathcal{S}}

\newcommand{\shj}{\mathcal{J}}
